// LogBuffer.h: interface for the CLogBuffer class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _LOG_BUFFER_
#define _LOG_BUFFER_

struct SLogEntry
{
	string sModule;
	string sTimeStamp;
	string sMessage;
};

typedef list<SLogEntry> TMsgList;
typedef TMsgList::iterator TMsgListIterator;

class CLogBuffer  
{
private:
	TMsgList m_cMsgList;

public:
	CLogBuffer();
	virtual ~CLogBuffer();

	KPDL_RESULT AddMsg(
		const string &sModule,
		const string &sTimeStamp,
		const string &sMessage
	);

	KPDL_RESULT Clear();
	KPDL_RESULT Show(
		CDC &cDevice, 
		const int iVSize, 
		const int iFontSize
	);
};

#endif // _LOG_BUFFER_
