// LogFrame.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLogFrame

IMPLEMENT_DYNCREATE(CLogFrame, CMDIChildWnd)

BEGIN_MESSAGE_MAP(CLogFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CLogFrame)
		ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
		ON_WM_SETFOCUS()
		ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChildFrame construction/destruction

CLogFrame::CLogFrame()
{
}

CLogFrame::~CLogFrame()
{
}

BOOL CLogFrame::PreCreateWindow(CREATESTRUCT& tCS)
{
	if(!CMDIChildWnd::PreCreateWindow(tCS))
		return FALSE;

	tCS.dwExStyle &= ~WS_EX_CLIENTEDGE;
	tCS.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CChildFrame message handlers
void CLogFrame::OnFileClose() 
{
	SendMessage(WM_CLOSE);
}

int CLogFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if(CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// create a view to occupy the client area of the frame
	if(!m_cLogView.Create(
		NULL, 
		NULL, 
		AFX_WS_DEFAULT_VIEW, 
		CRect(0, 0, 0, 0), 
		this, 
		AFX_IDW_PANE_FIRST, 
		NULL
	))
		return -1;

	return 0;
}

void CLogFrame::OnSetFocus(CWnd* pOldWnd) 
{
	CMDIChildWnd::OnSetFocus(pOldWnd);
	m_cLogView.SetFocus();
}

BOOL CLogFrame::OnCmdMsg(
	UINT nID, 
	int nCode, 
	void* pExtra, 
	AFX_CMDHANDLERINFO* pHandlerInfo
) 
{
	// let the view have first crack at the command
	if(m_cLogView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;
	
	// otherwise, do default handling
	return CMDIChildWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
