//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	LogMain.h
 *  \brief Hlavny hlavickovy subor "logovacieho modulu"
 *  \author t0n0 Weissensteiner & Mato Spal
 *  \date 26.2.2002 22:42:51
 *  \version 1.0
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef _LOG_MAIN_
#define _LOG_MAIN_

#pragma warning (disable : 4786)

/////////////////////////////////////////////////////////////////////
// Platform dependent header
#define VC_EXTRALEAN
#include <afx.h>
// MFC support for Windows Common Controls
#include <afxcmn.h>

/////////////////////////////////////////////////////////////////////
// Standard header files
#include <stdio.h>
#include <stdarg.h>
#include <string>
#include <list>
#include <map>

using namespace std;

/////////////////////////////////////////////////////////////////////
// Library settings
#define LOG_MAX_MSG			256
#define LOG_MAX_BUFFER		1024
#define LOG_MAX_TIMESTAMP	12
#define LOG_ACCESS_MODE_W	"w"
#define LOG_ACCESS_MODE_A	"a"
#define LOG_FONT_NAME		"Courier New"
#define LOG_FONT_SIZE		15
#define LOG_FILE_POS		2
#define LOG_TIME_POS		82
#define LOG_MSG_POS			162

enum LOG_MASK
{
	LOG_MASK_EMPTY  = 0x00000000,
	LOG_MASK_SYSTEM = 0x00000001,
	LOG_MASK_PARSER = 0x00000002,
	LOG_MASK_FULL   = 0xFFFFFFFF
};

/////////////////////////////////////////////////////////////////////
// Library header files
#include "results.h"
#include "log.h"
#include "logview.h"
#include "logframe.h"
#include "logbuffer.h"
#include "logmanager.h"

/////////////////////////////////////////////////////////////////////
// Global objects
extern CLogManager cLogManager;
extern CLog cSystemLog;
extern CLog cParserLog;

#endif // _LOG_MAIN_