//*****************************************************************************
// Activate.h: Interface of the CActivate class
//*****************************************************************************

#ifndef _ACTIVATE_
#define _ACTIVATE_

//*****************************************************************************
class CActivate
{
// Memebers
public:
	double dMin;
	double dMax;

// Methods
public:
	CActivate(
		const double dNewMin, 
		const double dNewMax
	)
	:	dMin(dNewMin), 
		dMax(dNewMax) 
	{
	}
	virtual ~CActivate() {}

	virtual double F(double dNet) = 0;
	virtual double DiffF(double dO) = 0;
};

//*****************************************************************************
class CBinaryUnipol : public CActivate
{
// Methods
public:
	CBinaryUnipol();
	
	double F(double dNet);
	double DiffF(double dO);
};

//*****************************************************************************
class CBinaryBipol : public CActivate
{
// Methods
public:
	CBinaryBipol();
	
	double F(double dNet);
	double DiffF(double dO);
};

//*****************************************************************************
class CContinuousUnipol : public CActivate
{
// Methods
public:
	CContinuousUnipol();
	
	double F(double dNet);
	double DiffF(double dO);
};

//*****************************************************************************
class CContinuousBipol : public CActivate
{
// Methods
public:
	CContinuousBipol();

	double F(double dNet);
	double DiffF(double dO);
};

#endif // _ACTIVATE_
