//*****************************************************************************
// Forward.h: interface of the CForwardNetwork class
//*****************************************************************************

#ifndef _FORWARD_
#define _FORWARD_

//*****************************************************************************
class CForwardNetwork  
{
// Members
public:
	// Configuration
	double dMomentum;
	double dAlpha;

private:
	// Limits
	int m_iSizeIn;
	int m_iSizeHid;
	int m_iSizeOut;
	// Weights
	CMatrix m_cWeightsHid;
	CMatrix m_cWeightsOut;
	// Weights updates
	CMatrix m_cDeltaHid;
	CMatrix m_cDeltaOut;
	// Temporal outputs from hidden layer
	CVector m_cOutputHid;
	CVector m_cOutputOut;
	// Activation function
	CActivate &m_cActivate;

// Methods
public:
	CForwardNetwork(
		const int iInputSize,
		const int iHiddenSize,
		const int iOutputSize,
		CActivate &cActivate,
		const double dMomentum = 0.0,
		const double dAlpha = 0.0
	);
	virtual ~CForwardNetwork(){}

/*	void Learn(
		const double dAlpha,
		const double dMomentum,
		CTrainSet &cTrainSet,
		const double dTolerance,
		const double dPrecision,
		const int iMaxStage,
		const bool bProgress
	);
*/
	void Process(CVector &cInput, CVector &cOutput, double dTolerance);

};

#endif // _FORWARD_
