//*****************************************************************************
// FILE:         Item.cpp 
// DESCRIPTION:  Generic list item
// PROJECT:      Evolution as an avalanche process
// AUTHOR:       Anton Weissensteiner
// DATE:         5.11.2001
//*****************************************************************************

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//*****************************************************************************
// Construction/Destruction
//*****************************************************************************

CItem::~CItem()
{
	if(m_pcPrev != NULL)
	{
		m_pcPrev->m_pcNext = m_pcNext;
	}

	if(m_pcNext != NULL)
	{
		m_pcNext->m_pcPrev = m_pcPrev;
	}

	m_pcPrev = NULL;
	m_pcNext = NULL;
}

//*****************************************************************************
// Methods/Operators
//*****************************************************************************

VOID CItem::AddPrev(CItem *pcNew)
{
	if(pcNew == NULL)
		return;

	CItem *pcNewFirst = pcNew->GetFirst();
	CItem *pcNewLast = pcNew->GetLast();

	pcNewLast->m_pcNext= this;
	if((pcNewFirst->m_pcPrev = m_pcPrev) != NULL)
	{
		m_pcPrev->m_pcNext = pcNewFirst;
	}
	m_pcPrev = pcNewFirst;
}

VOID CItem::AddNext(CItem *pcNew)
{
	if(pcNew == NULL)
		return;

	CItem *pcNewFirst = pcNew->GetFirst();
	CItem *pcNewLast = pcNew->GetLast();

	pcNewFirst->m_pcPrev = this;
	if((pcNewLast->m_pcNext = m_pcNext) != NULL)
	{
		m_pcNext->m_pcPrev = pcNewLast;
	}
	m_pcNext = pcNewFirst;
}

CItem *CItem::GetFirst()
{
	CItem *pcFirst = this;

	while(!pcFirst->IsFirst())
	{
		pcFirst = pcFirst->GetPrev();
	}

	return pcFirst;
}

CItem *CItem::GetLast()
{
	CItem *pcLast = this;

	while(!pcLast->IsLast())
	{
		pcLast = pcLast->GetNext();
	}

	return pcLast;
}
