//*****************************************************************************
// FILE:         Item.h
// DESCRIPTION:  Generic list item
// PROJECT:      Evolution as an avalanche process
// AUTHOR:       Anton Weissensteiner
// DATE:         5.11.2001
//*****************************************************************************

#ifndef _ITEM_
#define _ITEM_

class CItem  
{
// Members
private:
	CItem *m_pcPrev;
	CItem *m_pcNext;

// Methods
public:
	CItem()
	:	m_pcPrev(NULL),
		m_pcNext(NULL)
	{
	}

	virtual ~CItem();

	void AddPrev(CItem *pcNew);
	void AddNext(CItem *pcNew);
	CItem *GetFirst();
	CItem *GetLast();

	CItem *GetPrev()
	{
		return m_pcPrev;
	}

	CItem *GetNext()
	{
		return m_pcNext;
	}

	bool IsFirst()
	{
		return m_pcPrev == NULL;
	}

	bool IsLast()
	{
		return m_pcNext == NULL;
	}
};

#endif // _ITEM_
