//*****************************************************************************
// Layer.h: interface of the CLayer class
//*****************************************************************************

#ifndef _LAYER_
#define _LAYER_

//*****************************************************************************
// Just an interface
class CLayer
{
// Members
protected:
	// Limits
	int m_iSizeIn;
	int m_iSizeOut;
	// Weights
	CMatrix m_cWeights;
	// Weights updates
	CMatrix m_cDiffW;
	// Activation function
	CActivate &m_cActivate;

// Methods
public:
	CLayer::CLayer(
		const int iSizeIn,
		const int iSizeOut,
		CActivate &cActivate
	);
	virtual ~CLayer() {}

	void OutputDelta(
		CVector &cDesired,
		CVector &cOutput,
		CVector &cDelta
	);

	void HiddenDelta(
		CVector &cDeltaIn,
		CVector &cOutput,
		CVector &cDelta
	);

	void Adapt(
		const double dAlpha,
		const double dMomentum,
		CVector &cDelta,
		CVector &cInput
	);
	
	void Process(
		CVector &cInput, 
		CVector &cOutput
	);
};

#endif // _LAYER_
