//*****************************************************************************
// FILE:         List.h
// DESCRIPTION:  Generic list item
// PROJECT:      Evolution as an avalanche process
// AUTHOR:       Anton Weissensteiner
// DATE:         5.11.2001
//*****************************************************************************

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//*****************************************************************************
// Methods/Operators
//*****************************************************************************

void CList::Append(CItem *pcNew)
{
	if(pcNew == NULL)
		return;

	if(m_pcCurrent != NULL)
		m_pcCurrent->AddNext(pcNew);

	m_pcCurrent = pcNew;
	m_iLength ++;
}

void CList::Insert(CItem *pcNew)
{
	if(pcNew == NULL)
		return;

	if(m_pcCurrent != NULL)
		m_pcCurrent->AddPrev(pcNew);

	m_pcCurrent = pcNew;
	m_iLength ++;
}

void CList::Delete()
{
	CItem *pcDelete = m_pcCurrent;
	
	if(pcDelete == NULL)
		return;
	
	if(m_pcCurrent->IsFirst())
		m_pcCurrent = m_pcCurrent->GetNext();
	else 
		m_pcCurrent = m_pcCurrent->GetPrev();

	delete pcDelete;
	m_iLength --;
}

void CList::Clear()
{
	if(m_pcCurrent == NULL)
		return;

	m_pcCurrent = m_pcCurrent->GetFirst();
	while(m_pcCurrent != NULL)
	{
		CItem *pcDelete = m_pcCurrent;
		m_pcCurrent = m_pcCurrent->GetNext();
		delete pcDelete;
	}

	m_iLength = 0;
}

bool CList::Contains(CItem *pcItem)
{
	if(m_pcCurrent == NULL)
		return FALSE;

	CItem *m_pcItem = m_pcCurrent->GetFirst();
	while(m_pcItem != NULL)
	{
		if(m_pcItem == pcItem)
			return TRUE;

		m_pcItem = m_pcItem->GetNext();
	}

	return FALSE;
}

bool CList::MovePrev()
{
	if(m_pcCurrent == NULL || m_pcCurrent->IsFirst())
		return FALSE;
	
	m_pcCurrent = m_pcCurrent->GetPrev();
	return TRUE;
}

bool CList::MoveNext()
{
	if(m_pcCurrent == NULL || m_pcCurrent->IsLast())
		return FALSE;

	m_pcCurrent = m_pcCurrent->GetNext();
	return TRUE;
}

bool CList::MoveFirst()
{
	if(m_pcCurrent == NULL)
		return FALSE;

	m_pcCurrent = m_pcCurrent->GetFirst();
	return TRUE;
}

bool CList::MoveLast()
{
	if(m_pcCurrent == NULL)
		return FALSE;

	m_pcCurrent = m_pcCurrent->GetLast();
	return TRUE;
}
