//*****************************************************************************
// FILE:         List.h
// DESCRIPTION:  Generic list class
// PROJECT:      Evolution as an avalanche process
// AUTHOR:       Anton Weissensteiner
// DATE:         5.11.2001
//*****************************************************************************

#ifndef _KPDL_LIST_
#define _KPDL_LIST_

class CList  
{
// Members
private:
	CItem *m_pcCurrent;
	int m_iLength;

// Methods
public:
	CList()
	:	m_pcCurrent(NULL),
		m_iLength(0)
	{
	}

	virtual ~CList()
	{
		Clear();
	}
	
	void Insert(CItem *pcNew);
	void Append(CItem *pcNew);
	void Delete();
	void Clear();

	bool MovePrev();
	bool MoveNext();
	bool MoveFirst();
	bool MoveLast();

	bool Contains(CItem *pcItem);

	bool IsEmpty()
	{
		return m_pcCurrent == NULL;
	}

	CItem *Item()
	{
		return m_pcCurrent;
	}

	int GetLength()
	{
		return m_iLength;
	}
};

#endif // _KPDL_LIST_
