//*****************************************************************************
// Matrix.h: interface of the CMatrix class
//*****************************************************************************

#ifndef _MATRIX_
#define _MATRIX_

class CMatrix  
{
// Members
private:
	static CRandom m_cInitVal;
	int m_iWidth;
	int m_iHight;
	double *m_pdStorage;

// Methods
public:
	CMatrix(
		const int iHight, 
		const int iWidth,
		const double dValue = 0.0
	);
	CMatrix(CMatrix &cSource);
	CMatrix(
		const int iHigth,
		const int iWidth,
		const double dBottom,
		const double dTop
	);
	virtual ~CMatrix();

	void Print(const char *sFormat);
	double &operator ()(const int iRow, const int iColumn);
	CMatrix &operator =(CMatrix &cSource);

	int GetWidth()
	{
		return m_iWidth;
	}

	int GetHight()
	{
		return m_iHight;
	}
};

#endif // _MATRIX_
