//*****************************************************************************
// Random.cpp: Implementation of the CRandom class
//*****************************************************************************

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Random generator parameters
#define COEFF           (1343714438i64)
#define MODUL           (2147483647i64)

// "Randomizer"
ULONG CRandom::m_ulSeed = 1;

//*****************************************************************************
// Construction/Destruction
//*****************************************************************************

CRandom::CRandom(ULONG ulValue /* = 0L */)
{
	if(ulValue > 0)
		Init(ulValue);
	else
		Randomize();
}

//*****************************************************************************
// Methods/Operators
//*****************************************************************************

double CRandom::Random()
{
	// Random value from <0,1> interval
	m_ulStatus = (COEFF * m_ulStatus) % MODUL;
	return (double) (m_ulStatus / MODUL);
}

void CRandom::Init(ULONG ulValue)
{
	// Defined state initialization
	m_ulStatus = ulValue;
}

void CRandom::Randomize()
{
	ULONG ulTime = GetTickCount();
	
	// Randomize the state
	m_ulStatus += m_ulSeed + ulTime;
	m_ulSeed += m_ulStatus;
}
