//*****************************************************************************
// Recurent.h: interface of the CRecurentNetwork class
//*****************************************************************************

#ifndef _RECURENT_
#define _RECURENT_

//*****************************************************************************
class CRecurentNetwork  
{
// Members
public:
	// Configuration
	double dMomentum;
	double dAlpha;

private:
	// Limits
	int m_iSizeIn;
	int m_iSizeRec;
	int m_iSizeOut;
	// Weights
	CMatrix m_cWeightsIn;
	CMatrix m_cWeightsRec;
	CMatrix m_cWeightsOut;
	// Weights updates
	CMatrix m_cDiffWIn;
	CMatrix m_cDiffWRec;
	CMatrix m_cDiffWOut;
	// Recurent layer output
	CVector m_cInputRec;
	// Activation function
	CActivate &m_cActivate;

// Methods
public:
	CRecurentNetwork(
		const int iSizeIn,
		const int iSizeRec,
		const int iSizeOut,
		CActivate &cActivate,
		const double dMomentum = 0.0,
		const double dAlpha = 0.0
	);
	virtual ~CRecurentNetwork(){}

	void Restart();

	void CountForward(
		CVector &cInputIn, 
		CVector &cInputRec,
		CVector &cOutputRec,
		CVector &cOutputOut
	);

	void CountBackward(
		CList &cInput,
		CVector &cDesired
	);

	void Process(
		CVector &cInput, 
		CVector &cOutput
	);

	void Process(
		CList &cInput, 
		CList &cOutput
	);
	
	void Learn(
//		CTrainSet &cTrainSet,
		const double dErrorLimit,
		const double dTolerance
	);
};

#endif // _RECURENT_
