//*****************************************************************************
// Vector.cpp: Implementation of the CVector class DBL_MAX
//*****************************************************************************

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//*****************************************************************************
// Construction/Destruction
//*****************************************************************************

CRandom CVector::m_cInitVal;

CVector::CVector(
	const int iLength,
	const double dValue /* = 0.0 */
)
:	iSize(0),
	m_pdStorage(NULL)
{
	int iIndex;

	m_pdStorage = new double[iLength];
	for(iIndex = 0; iIndex < iLength; iIndex++)
		m_pdStorage[iIndex] = dValue;

	iSize = iLength;
}

CVector::CVector(CVector &Source)
:	iSize(0),
	m_pdStorage(NULL)
{
	int iLength = Source.iSize;

	m_pdStorage = new double[iLength];
	memcpy(m_pdStorage, Source.m_pdStorage, iLength * sizeof(double));
	iSize = iLength;
}

CVector::CVector(
	const int iLength,
	const double dBottom,
	const double dTop
)
:	iSize(0),
	m_pdStorage(NULL)
{
	double dScope = dTop - dBottom;
	int iIndex;

	m_pdStorage = new double[iLength];
	for(iIndex = 0; iIndex < iLength; iIndex ++)
		m_pdStorage[iIndex] = dBottom + dScope * m_cInitVal.Random();

	iSize = iLength;
}

CVector::~CVector() 
{
	if(m_pdStorage != NULL)
	{
		delete m_pdStorage;
		m_pdStorage = NULL;
	}
	iSize = 0;
}

//*****************************************************************************
// Methods/Operators
//*****************************************************************************

void CVector::Print(const char *sFormat)
{
	int iIndex;

	for(iIndex = 0; iIndex < iSize; iIndex ++)
		printf(sFormat, m_pdStorage[iIndex]);

}

double &CVector::operator ()(const int iIndex)
{
#ifdef CHECK_INDEX
	if(iIndex >= iSize || m_pdStorage == NULL)
		return *NULL;
#endif // CHECK_INDEX

	return m_pdStorage[iIndex];
}

CVector &CVector::operator =(CVector &Source)
{
#ifdef CHECK_INDEX
	if(iSize != Source.iSize)
		return *NULL;
#endif // CHECK_INDEX

	memcpy(m_pdStorage, Source.m_pdStorage, iSize * sizeof(double));
	return(*this);
}
