// Condition.cpp: implementation of the CCondition class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCondition::CCondition()
{
}

CCondition::~CCondition()
{
}

KPDL_RESULT CCondition::SetXML(IXMLDOMNodePtr &pNode)
{
	_variant_t vValue;

	pNode->attributes->getNamedItem("variable")->get_nodeValue(&vValue);
	sVariable = _bstr_t(vValue);

	pNode->attributes->getNamedItem("operator")->get_nodeValue(&vValue);
	sOper = _bstr_t(vValue);

	pNode->attributes->getNamedItem("value")->get_nodeValue(&vValue);
	sConst = _bstr_t(vValue);

	return KPDL_SUCCESS;
}

bool CCondition::Evaluate(CQuery &cQuery)
{
	string sVarValue = cQuery.Evaluate(sVariable);

	bool bResult = 
		(sOper == ">"  && sVarValue > sConst)  ||
		(sOper == ">=" && sVarValue >= sConst) ||
		(sOper == "==" && sVarValue == sConst) ||
		(sOper == "<=" && sVarValue <= sConst) ||
		(sOper == "<"  && sVarValue < sConst)  ||
		(sOper == "!=" && sVarValue != sConst);

	cParserLog.Write(
		true, 
		"    podmienka: %s %s %s; %s = '%s'; %s", 
		sVariable.c_str(),
		sOper.c_str(),
		sConst.c_str(),
		sVariable.c_str(),
		sVarValue.c_str(),
		(bResult)? "plati" : "neplati"
	);

	return bResult;
}
