// Query.h: interface for the CQuery class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _QUERY_
#define _QUERY_

class CTerm;

typedef vector<CTerm *> TTermVector; 
typedef TTermVector::iterator TTermVectorIterator; 

class CTerm
{
public:
	string sName;

public:
	CTerm(){}
	virtual ~CTerm() {}

	virtual string Evaluate() = 0;
};

class CQuery  
{
private:
	TTermVector m_cTermList;

public:
	CQuery() {}
	virtual ~CQuery();

	virtual string Evaluate(const string &sVarName);

	KPDL_RESULT AddTerm(CTerm *pTerm)
	{
		m_cTermList.push_back(pTerm);
		return KPDL_SUCCESS;
	}
};

#endif // _QUERY_
