// PlayerApp.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CPlayerApp theApp;
CConfig *cfg = NULL;

extern string g_sTeamName;
extern string g_sServerAddress;
extern UINT g_sServerPort;

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp
CPlayerApp::CPlayerApp()
{
}

CPlayerApp::~CPlayerApp()
{
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp initialization

BOOL CPlayerApp::InitInstance()
{
	if(!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	// Call this when using MFC in a shared DLL
	Enable3dControls();
#else
	// Call this when linking to MFC statically
	Enable3dControlsStatic();
#endif

	// Change the registry key under which our settings are stored.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	// To create the main window, this code creates a new frame window
	// object and then sets it as the application's main window object.
	CMDIFrameWnd* pFrame = new CMainFrame;
	m_pMainWnd = pFrame;

	// create main MDI frame window
	if (!pFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;

	// try to load shared MDI menus and accelerator table
	HINSTANCE hInst = AfxGetResourceHandle();
	m_hMDIMenu  = ::LoadMenu(hInst, MAKEINTRESOURCE(IDR_MAINFRAME));
	m_hMDIAccel = ::LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_MAINFRAME));

    // defaultne nastavenia vizualizatora
	m_bDrawPerceptions = true;
	m_bDrawTeammateInfo = true;
	m_bDrawOpponentInfo = true;
	m_bDrawBallInfo = true;
	m_bDrawLocalAgentInfo = true;

	// The main window has been initialized, so show and update it.
	pFrame->ShowWindow(m_nCmdShow);
	pFrame->UpdateWindow();

    CCmdLineInfo cCmdInfo;
	ParseCommandLine(cCmdInfo);

    // FIXME
    ::cfg = new CConfig;
    ::cfg->Load("server.conf");
    ::cfg->Load(cCmdInfo.m_sAgentCfgName);
    ::cfg->AssignValues();

    g_sServerAddress = ::cfg->app_connect_server;
    g_sServerPort = ::cfg->app_connect_port;
    g_sTeamName = ::cfg->app_team_name;

    if(::cfg->app_autoconnect)
	{
        if(::cfg->app_autoconnect_goalie)
            ((CMainFrame *)m_pMainWnd)->OnServerConnectGoalie();
        else
            ((CMainFrame *)m_pMainWnd)->OnServerConnect();

        if(::cfg->app_autoconnect_dummy)
		{
            Sleep(1000);
            ((CMainFrame *)m_pMainWnd)->OnServerDisconnect();
        }
    }

	return TRUE;
}

int CPlayerApp::ExitInstance() 
{
    if(::cfg)
	{
		delete ::cfg;  
		::cfg = NULL;
	}

	if(m_hMDIMenu != NULL)
		FreeResource(m_hMDIMenu);
	if(m_hMDIAccel != NULL)
		FreeResource(m_hMDIAccel);

	return CWinApp::ExitInstance();
}

void CPlayerApp::OnFileTextNew()
{
	CMainFrame *pFrame = STATIC_DOWNCAST(CMainFrame, m_pMainWnd);

    if(pFrame->m_pCoordinatorThread)
	{
	    // Uz bude len jedno logovacie okno :(
		if(cLogManager.pLogView == NULL)
		{
			// Este neexistuje, vytvorime ho
			(CLogFrame *)pFrame->CreateNewChild(
				RUNTIME_CLASS(CLogFrame),
				IDR_MAINFRAME,
				m_hMDIMenu,
				m_hMDIAccel
			);
		}
		else
		{
			// Ak existje, dame mu fokus
			cLogManager.pLogView->GetParent()->SetFocus();
		}
    }
}

/////////////////////////////////////////////////////////////////////////////
// CPlayerApp message handlers

BEGIN_MESSAGE_MAP(CPlayerApp, CWinApp)
	//{{AFX_MSG_MAP(CPlayerApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CPlayerApp::OnFileNew() 
{
	CMainFrame* pFrame = STATIC_DOWNCAST(CMainFrame, m_pMainWnd);

	// create a new MDI child window
   	if(pFrame->m_pCoordinatorThread)
	{
	    pFrame->CreateNewChild(
		    RUNTIME_CLASS(CChildFrame),
			IDR_MAINFRAME, 
			m_hMDIMenu,
			m_hMDIAccel
		);
    }
}

void CPlayerApp::OnAppAbout()
{
	CAboutDlg cAbout;
	cAbout.m_sVersion = PLAYER_VERSION;
	cAbout.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CCmdLineInfo implementation 
void CCmdLineInfo::ParseParam(
	LPCTSTR lpszParam, 
	BOOL bFlag, 
	BOOL bLast
)
{
    // prvy arcument, ktory nie je typ 
    if(!bFlag)
        m_sAgentCfgName = lpszParam;
}

/////////////////////////////////////////////////////////////////////////////
// About dialog implementation
CAboutDlg::CAboutDlg()
:	CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_sVersion = _T(" ");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_VERSION_ID, m_sVersion);
	DDV_MaxChars(pDX, m_sVersion, 25);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
