//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	StrategicSkills.cpp
 *  \brief Implementacia strategickeho rozhodovania hraca
 *  \author Rado Kostelnik
 *  \date 13.3.2002 21:56:16
 *  \version 

 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CStrategicSkills::CStrategicSkills(
	CLocalAgent* pAgent, 
	const string &sFileName
)
:	m_pAgent(pAgent), 
	m_cDispQuery(pAgent)
{
	m_cRuleEngine.LoadXML(sFileName);
}

CStrategicSkills::~CStrategicSkills()
{

}

void CStrategicSkills::Deliberate()
{
	TActionVector cActionList;
	string sResult;
	char sBuffer[100];
	int iPriority = 0;
	TParameterBSkillsVector cParamList;

	// Novy rozhodovaci cyklus
	cParserLog.Write(
		true, 
		"------------------------------------------------------------"
	);

	m_cRuleEngine.Evaluate("default", m_cDispQuery, cActionList);

	TActionVectorIterator pActionIter = cActionList.begin();
	TActionVectorIterator pActionEnd = cActionList.end();

	for(; pActionIter != pActionEnd; pActionIter++ )
	{
		CAction *pAction = (*pActionIter);

		//
		// SetFormation
		//
		if(pAction->sName == "SetFormation")
		{
			CRuleParameter& r = pAction->cParamList[0];
			m_VarMap.insert( TVariableMap::value_type("formation", r.sValue) );	
		}
	}
}


//======================================================
// CLocalAgent : CDispatch implementacia
//======================================================
CDispatch* CStrategicSkills::getDispatch( string sName )
{
	string sRetValue;
	CDispatch* d = NULL;

	//-------------------------------------------------------
	// me (reflexia)
	//-------------------------------------------------------
	if ( sName == "me" )
	{
		d = (CDispatch*) this;
	}
	
	return d;
}

string CStrategicSkills::getAttribute( string sName )
{
	string sResult;
	char buf[100];

	if ( sName == "formation" )
	{
		string varValue;

		varValue = m_VarMap[string("formation")];
		sResult = varValue;
	}
	else
	if  ( sName == "state" )
	{
		sResult = "winning";
	}

	return sResult;
}