//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	AbstractBasicSkills.cpp
 *  \brief implementacia metod tried CBasicSkill, CBasicSkillList, CCatch, CDribble
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++


#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////CBasicSkill/////////////////////////

CBasicSkill::CBasicSkill(int skillType, int priority, CLocalAgent *agent) 
{
	m_skillType = skillType;
	m_priority = priority;
	m_agent = agent;
	m_localSituation = new CEstimateLocalSituation;
};

CBasicSkill::~CBasicSkill()
{
	delete m_localSituation;
};

CBasicSkill::CBasicSkill(const CBasicSkill &skill) 
{
	m_skillType = skill.m_skillType;
	m_priority = skill.m_priority;
	m_agent = skill.m_agent;
	m_accel = skill.m_accel;
	m_power = skill.m_power;
	m_dir = skill.m_dir;
	m_moment = skill.m_moment;
	m_pos = skill.m_pos;
	m_skillSkillType = skill.m_skillSkillType;
}

CBasicSkill::operator=(CBasicSkill &skill) 
{
	m_skillType = skill.GetSkillType();
	m_priority = skill.GetPriority();
	m_agent = skill.GetAgent();
	m_accel = skill.m_accel;
	m_power = skill.m_power;
	m_dir = skill.m_dir;
	m_moment = skill.m_moment;
	m_pos = skill.m_pos;
	m_skillSkillType = skill.m_skillSkillType;
}; 

bool operator<(CBasicSkill  &lhs, CBasicSkill &rhs) 
{
	return(lhs.GetPriority() < rhs.GetPriority());
};

bool operator==( CBasicSkill  &lhs,  CBasicSkill &rhs) 
{
	return(lhs.GetPriority() == rhs.GetPriority());
};

bool operator<=( CBasicSkill  &lhs,  CBasicSkill &rhs) 
{
	return(lhs.GetPriority() == rhs.GetPriority());
};

void CBasicSkill::Execute()
{
};

int CBasicSkill::IsTypeOf(int type) 
{
	if(m_skillSkillType - type > 0 && m_skillSkillType - type <100) return true;
	return false;
}

///////////////////////////CBasicSkillList////////////////////////////////

//------------------------------------------------------
/*! \fn	void CBasicSkillList::EvaluateAndRemove() 
 *  \brief Vyhodnoti zakladnu schopnost s najvysou prioritou
 *  \return
 *  \author Rado Otipka
 *  \date 3. 12. 2001 20:20:22

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CBasicSkillList::EvaluateAndRemove() 
{
	if(!IsEmpty()) {
		int tmp =-1;
		int index = -1,i;
		for( i =0;i<m_skillsList.GetSize();i++) {
			if(!m_skillsList[i]->IsTypeOf(BSKILL_TURN_NECK) && !m_skillsList[i]->IsTypeOf(BSKILL_SAY)) {
				if( m_skillsList[i]->GetPriority() > tmp) {
					tmp = m_skillsList[i]->GetPriority();
					index = i;
				}
			}
		}
		////////////////
		if(m_skillsList[index]->GetSkillType() == BSKILL_MANAGE) {
			if( ((CManage *) m_skillsList[index])->GetSkillSkillType() == BSKILL_MANAGE_REMOVEALL ) Empty();
		} else {
			if(index>-1)
				m_skillsList[index]->Execute();
		}
		if( index > -1 && m_skillsList.GetSize() > 0) {
			if(m_skillsList[index] != NULL) { 
				delete m_skillsList[index];
				m_skillsList[index] =NULL;
			}
			m_skillsList.RemoveAt(index);
		}
		///////////vyber najblizsi turn neck s najvecsou prioritou a spusti
		tmp = -1;
		index = -1;
		for( i=0;i<m_skillsList.GetSize();i++ ) {
			if( m_skillsList[i]->IsTypeOf(BSKILL_TURN_NECK) ) {
				if(m_skillsList[i]->GetPriority() > tmp) {
					tmp = m_skillsList[i]->GetPriority();
					index = i;
				}
			}
		}
		if(index > -1)	m_skillsList[index]->Execute();
		if( index > -1 && m_skillsList.GetSize() > 0) {
			
			if(index > -1 && m_skillsList[index] != NULL) { 
				delete m_skillsList[index];
				m_skillsList[index] =NULL;
			}
			m_skillsList.RemoveAt(index);
		}
		///////
		////vyber najblizsi say a spusti
		tmp = -1;
		index = -1;
		for( i=0;i<m_skillsList.GetSize();i++ ) {
			if( m_skillsList[i]->IsTypeOf(BSKILL_SAY) ) {
				if(m_skillsList[i]->GetPriority() > tmp) {
					tmp = m_skillsList[i]->GetPriority();
					index = i;
				}
			}
		}
		if(index > -1) m_skillsList[index]->Execute();
		if( index > -1 && m_skillsList.GetSize() > 0) {
			if(m_skillsList[index] != NULL) { 
				delete m_skillsList[index];
				m_skillsList[index] =NULL;
			}
			m_skillsList.RemoveAt(index);
		}
		/////
	}		
};


void CBasicSkillList::Empty() 
{
	for( int i = 0; i<m_skillsList.GetSize(); i++ ) {
		delete m_skillsList[i];
	}
	m_skillsList.RemoveAll();
}

CBasicSkillList::CBasicSkillList() {};
CBasicSkillList::~CBasicSkillList() 
{
	Empty();
}

////////////////////////////////CCatch/////////////////////////////////////////////

//------------------------------------------------------
/*! \fn	void CCatch::Catch( double dir )
 *  \brief chytenie lopty do ruk
 *  \param  double dir
 *  \return
 *  \author Rado Kostelnik
 *  \date 3. 12. 2001 20:21:49

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CCatch::Catch( C2DVector ballPos)
{
	if( m_localSituation->BallCatchable(GetAgent()) )
	{
		C2DVector toball = m_localSituation->RelVectorTo( GetAgent(), ballPos );
		CGameCommand *pGameCommand = new CGameCommand();
		pGameCommand->Catch(RadToDeg(AngNormalise(toball.GetAngle())));
		GetAgent()->actionseq->AddGameCommand(pGameCommand);
	}
}

CCatch::CCatch( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority ) :CBasicSkill( BSKILL_MOVE, priority, pl ) 
{
	double m_accel = 0, posX = 0, posY = 0;
	m_accel = 0;
	TParameterBSkillsVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_ANGLE )
				sscanf( index->value.data(), "%d", &m_dir );
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY );	
}

void CCatch::Execute() 
{
	switch( m_skillSkillType ) {
	case BSKILL_CATCH_BASIC: Catch( m_pos );
		break;
	}

}

/////////////////////////////////CSay/////////////////////////////////////
CSay::CSay( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority ) :CBasicSkill( BSKILL_MOVE, priority, pl ) 
{
	string coje;
	m_skillSkillType = BSKILL_SAY_IT;
	TParameterBSkillsVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_SAYSTRING ) {		
			m_saystring = index->GetValue();
		}
	}
}

void CSay::Execute()
{
	switch( m_skillSkillType ) {
	case BSKILL_SAY_IT: Say( m_saystring );
		break;
	}
}

void CSay::Say(string &str) 
{
    CGameCommand *pGameCommand = new CGameCommand();    
    pGameCommand->Say(str);
    GetAgent()->actionseq->AddGameCommand(pGameCommand);
}
//////////////////////////////////////////////////////////////////////////

///////////////////////CChangeView////////////////////////////////////
CChangeView::CChangeView(TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority ) : CBasicSkill( BSKILL_MOVE, priority, pl ) 
{
	string coje;
	m_width = 0;
	m_quality = 0;
	m_skillSkillType = BSKILL_CHAGEVIEW_NOW;
	TParameterBSkillsVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_WIDTH ) {		
			sscanf( index->value.data(), "%d", &m_width );		
		}
		if( index->name == VALUE_QUALITY ) {		
			sscanf( index->value.data(), "%d", &m_quality );		
		}
	}
}

///////////////////////////////////////////////////////////////////////
void CChangeView::ChangeView(int width, int res) 
{
	//////////////////////
	EViewWidth widthE ;
	widthE = EViewWidth(width);
	EViewQuality quality = EViewQuality(res);
	CGameCommand *pGameCommand = new CGameCommand();    
    pGameCommand->ChangeView(widthE,quality);
    GetAgent()->actionseq->AddGameCommand(pGameCommand);
	//////////////////////
}
//void ChangeView(EViewWidth width, EViewQuality quality) 

void CChangeView::Execute()
{
	switch( m_skillSkillType ) {
	case BSKILL_CHAGEVIEW_NOW: ChangeView(m_width, m_quality );
		break;
	}
}
//////////////////////////////////////////////////////////////////////////