// Coordinator.cpp : implementation file
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//! t0n0
//FILE *m_ff;

/////////////////////////////////////////////////////////////////////////////
// CCoordinator

IMPLEMENT_DYNCREATE(CCoordinator, CWinThread)

CEventDispatcher EventDispatcher;

CCoordinator::CCoordinator() : m_pServerConnection(NULL)
{
}

CCoordinator::~CCoordinator()
{
}

void CCoordinator::Deliberate(CGameTime cGameTime, CPerceptionSeq *pPerceptionSeq, CGameCommandSeq *pGameCommandSeq)
{
    CGameCommandSeq *pActCommands;

    pActCommands = new CGameCommandSeq;

    m_pSoccerAgent->OnDeliberateEvent(cGameTime, pPerceptionSeq, pGameCommandSeq, pActCommands);

    if (pActCommands->GetGameCommandsCount() > 0) {
        static CSendDataEvent event;
        event.m_eType = ET__SEND_COMMANDS;
        event.m_pGameCommandSeq = pActCommands;
		//!fprintf(m_ff, "<send>\n");
        //!LOGMSG( 1, "<send>" );
            
        EventDispatcher.SendEvent(&event);
    } else {
        delete pActCommands;
    }

    return;
}

void CCoordinator::Handle()
{
    EEventType eType;

    do {
        eType = EventDispatcher.m_pEvent->m_eType;
        if (eType == ET__NONE) break;
        EventDispatcher.m_pEvent->m_eType = ET__NONE;  // FIXME - nepekne

        switch (eType) {
        case ET__RECEIVED_MSG:
            m_pServerCommunicator->OnReceiveServerMsg();
            break;
        case ET__START_DELIBERATION:
            {
                CStartDeliberationEvent *pDeliberationEvent = (CStartDeliberationEvent *)EventDispatcher.m_pEvent;
                Deliberate(pDeliberationEvent->m_cGameTime, pDeliberationEvent->m_pPerceptionSeq, pDeliberationEvent->m_pGameCommandSeq); // FIXME + dalsie parametre
                break;
            };
        case ET__SEND_COMMANDS:
            {
                CSendDataEvent *pSendEvent = (CSendDataEvent *)EventDispatcher.m_pEvent;
                m_pServerCommunicator->SendCommands(pSendEvent->m_pGameCommandSeq);
                delete pSendEvent->m_pGameCommandSeq;
                break;
            };
        }
    } while (1);
}

string g_sServerAddress = "localhost";
UINT g_sServerPort = 6000;
bool g_bCoordinatorInitGoalie = false;
CSoccerAgent *g_pSoccerAgent = NULL;
string g_sTeamName;

BOOL CCoordinator::InitInstance()
{
    //! t0n0
	//m_ff = fopen("log.log", "wt");

    EventDispatcher.m_pCoordinator = this;

    m_pSoccerAgent = new CSoccerAgent;
    g_pSoccerAgent = m_pSoccerAgent;
    

	/* CServerConnection sa vytvori az tu, aby sa zarucilo ze jeho message sink
	   bude v novom threade.
	*/
	AfxSocketInit();

    m_pSystemClock = new CSystemClock();
    m_pSystemClock->Initialize();   // FIXME: alebo Initialise()??

    m_pServerMsgTranslator = new CServerMsgTranslator();

    m_pPerceptionSeq = new CPerceptionSeq();

//    CGameCommandSeq *m_pSendCommandSeq; 
//    CGameCommandSeq *m_pSentCommandSeq; 
//    m_pSendCommandSeq = new CGameCommandSeq();
//    m_pSentCommandSeq = new CGameCommandSeq();

/*
CPerception rPrc;
CServerMsg mMsg;
mMsg.m_sMessage = "(init l 1 before_kick_off)";
m_pServerMsgTranslator->ParseServerMsg(&mMsg, &rPrc);

mMsg.m_sMessage = "(see 0 ((goal r) 66.7027 33) ((flag r t) 55.581 3) ((flag p r t) 42.4804 23) ((flag p r c) 53.7587 43))";
m_pServerMsgTranslator->ParseServerMsg(&mMsg, &rPrc);

mMsg.m_sMessage = "(hear 1134 referee play_on)";
m_pServerMsgTranslator->ParseServerMsg(&mMsg, &rPrc); */

    m_pGameState = new CGameState();

    // FIXME nesmu zavisiet priamo navzajom
	m_pServerConnection = new CServerConnection();
    m_pServerCommunicator = new CServerCommunicator();

    m_pServerConnection->Initialize(m_pSystemClock, m_pServerCommunicator);
    m_pServerCommunicator->Initialize(m_pGameState, m_pPerceptionSeq, m_pSystemClock, m_pServerConnection, m_pServerMsgTranslator);

	// FIXME: malo by sa volat priamo z hraca!
	m_pServerConnection->Connect(g_sServerAddress.c_str(), g_sServerPort);
#ifndef KPDL_PROTOKOL7    
	if (!g_bCoordinatorInitGoalie) {
	    m_pServerConnection->SendMsg(CServerMsg("(init "+g_sTeamName+" (version 6.00))"));
    } else {
        m_pServerConnection->SendMsg(CServerMsg("(init "+g_sTeamName+" (version 6.00) (goalie))"));
    }
#else
    if (!g_bCoordinatorInitGoalie) {
	    m_pServerConnection->SendMsg(CServerMsg("(init "+g_sTeamName+" (version 7.00))"));
    } else {
        m_pServerConnection->SendMsg(CServerMsg("(init "+g_sTeamName+" (version 7.00) (goalie))"));
    }
#endif
//	Sleep( 2000 );
//	m_pServerConnection->SendMsg(CServerMsg("(move 0 0)"));

/*	// odkomentuj pre rychly timer - treba este odkomentovat aj dva riadky v ExitInstance()
	TIMECAPS tc;
	timeGetDevCaps(&tc, sizeof (tc));
	TRACE("MaxPeriod: %d, MinPeriod %d\n", tc.wPeriodMax, tc.wPeriodMin);

	// !!!!! ta 50 dole znamena ze chces 50 milisekundovu presnost -
	// cim mensiu chces tym vacsia zataz systemu, hod tam nejvacsi cas aky potrebujes
	m_uTimerRes = min(max(tc.wPeriodMin, 50), tc.wPeriodMax);
	timeBeginPeriod(m_uTimerRes);

	// prvy paramter, je interval v ms - nemoze byt mensi, nez zvolena presnost timer,
	// takze presnost musi myt GCD vsetkych timerov ktore pustat
	// druhy parameter je resolution - presnost - 0 nejlepsia - tusim je to kolko ms plus minus
	// ti este nevadi
	m_wTimerID = timeSetEvent(10, 0, TimeProc, (unsigned long) this, TIME_PERIODIC); */

//!	TRACE("Coordinator thread running.\n");

	return TRUE;
}

int CCoordinator::ExitInstance()
{
    if (m_pServerConnection)
        m_pServerConnection->SendMsg(CServerMsg("(bye)"));

//!	TRACE("Coordinator thread exiting.\n");

/*	// odkomentuj pre rychly timer
	timeKillEvent(m_wTimerID);
	timeEndPeriod(m_uTimerRes); */

    if (m_pServerCommunicator)
        delete m_pServerCommunicator;
	if (m_pServerConnection)
		delete m_pServerConnection;
    if (m_pServerMsgTranslator)
        delete m_pServerMsgTranslator;
    if (m_pSystemClock)
        delete m_pSystemClock;

    if (m_pPerceptionSeq)
        delete m_pPerceptionSeq;

    if (m_pGameState)
        delete m_pGameState;

    if (m_pSoccerAgent)
        delete m_pSoccerAgent;

    //! t0n0
	//fclose(m_ff);

	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CCoordinator, CWinThread)
	//{{AFX_MSG_MAP(CCoordinator)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoordinator message handlers


/////////////////////////////////////////////////////////////////////////////
// Globalna funkcia pre rychly timer

void CALLBACK TimeProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	((CCoordinator*) dwUser)->OnMMTimer();
}

// !!!!!!!!!! Pozor! bezi v inom threade ako zvysok objektu CCoordinator!
void CCoordinator::OnMMTimer()
{
//    fprintf(m_ff, "MMTimer[ %d].\n", m_pSystemClock->GetTime());
//    m_pServerConnection->OnReceive2(0);
//!    TRACE("MMTimer[%d].\n", m_pSystemClock->GetTime());
}
