// DispatchQuery.cpp: implementation of the CDispatchQuery class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DispatchQuery.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDispatchQuery::CDispatchQuery(CLocalAgent *pAgent) : m_pLocalAgent ( pAgent )
{

}

CDispatchQuery::~CDispatchQuery()
{

}

string CDispatchQuery::Evaluate(const string &sVarName)
{
	CDispatch *d;
	TDispatchTermVector *tv;
	TDispatchTermVectorIterator tvi;
	TDispatchTermVectorIterator tve;
	string sTerm; 
	string sRetValue;
	long len;

	// rozloz vyraz na termy
	tv = CDispatch::getTerms( sVarName );
	if ( !tv )
		return string("N/A");

	// zisti prvy term - globalny objekt
	tvi = tv->begin();
	tve = tv->end();
	sTerm = *tvi++;
	tve--;

	len = tv->size();

	d = getGlobalObject( sTerm );

	if ( !d ) 
		return string("N/A");

	while ( tvi != tve )
	{
		sTerm = *tvi++;

		d = d->getDispatch( sTerm );
		if ( !d ) 
			return string("N/A");
	}

	sTerm = *tvi;
	sRetValue = d->getAttribute( sTerm );

	delete tv;

	return sRetValue;
}

CDispatch* CDispatchQuery::getGlobalObject(const string &sName)
{
	CDispatch* d = NULL;
	
	if ( sName == "ball" )
	{
		d = (CDispatch*) m_pLocalAgent->GetWorldModel()->GetBall(); 
	}
	else if ( sName == "me" )
	{
		d = (CDispatch*) m_pLocalAgent;
	}
	else if ( sName == "game" )
	{
		d = (CDispatch*) m_pLocalAgent->strategicSkills;
	}
	else if ( sName == "strategy" )
	{
		d = (CDispatch*) m_pLocalAgent->strategicSkills;
	}

	return d;
}
