// ParameterQuery.h: interface for the CParameterQuery class
//
//////////////////////////////////////////////////////////////////////

#ifndef _PARAMETERQUERY_H_
#define _PARAMETERQUERY_H_

class CParameterQuery;

class CParameterQuery : public CQuery
{
public:
	CParameterQuery(CLocalAgent *pAgent = NULL);
};


class CBestLocatedTeamMateTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CBestLocatedTeamMateTerm(CLocalAgent *pAgent)
	:	m_pAgent(pAgent)
	{
		sName = "BestLocatedTeamMate";
	};

	string Evaluate();
};

class CFreePositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CFreePositionTerm(CLocalAgent *pAgent)
	:	m_pAgent(pAgent)
	{
		sName = "FreePosition";
	};

	string Evaluate();
};

class CBestLocationForPassTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CBestLocationForPassTerm(CLocalAgent *pAgent)
	:	m_pAgent(pAgent)
	{
		sName = "BestLocationForPass";
	};

	string Evaluate();
};

class CActionPositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CActionPositionTerm(CLocalAgent *pAgent)
	:	m_pAgent(pAgent)
	{
		sName = "ActionPosition";
	};

	string Evaluate();
};

class CStrategicPositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CStrategicPositionTerm(CLocalAgent *pAgent)
	:	m_pAgent(pAgent)
	{
		sName = "StrategicPosition";
	};

	string Evaluate();
};

class CBallInterceptPositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CBallInterceptPositionTerm(CLocalAgent *pAgent)
	:	m_pAgent(pAgent)
	{
		sName = "BallInterceptPosition";
	};

	string Evaluate();
};

class CBallPositionTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CBallPositionTerm(CLocalAgent *pAgent)
	:	m_pAgent(pAgent)
	{
		sName = "BallPosition";
	};

	string Evaluate();
};

class CGoalTerm : public CTerm
{
private:
	CLocalAgent *m_pAgent;

public:
	CGoalTerm(CLocalAgent *pAgent)
	:	m_pAgent(pAgent)
	{
		sName = "Goal";
	};

	string Evaluate();
};

#endif // _PARAMETERQUERY_H_
