//*****************************************************************************
// OneHot.h: Interface of the COneHot class
//*****************************************************************************

#ifndef _ONE_HOT_
#define _ONE_HOT_

//*****************************************************************************
class COneHot  
{
// Members
private:
	STR m_sAlphabet;
	INT m_iSize;

// Methods
public:

	COneHot(
		const STR sAlphabet = NULL
	)
	:	m_sAlphabet(NULL),
		m_iSize((INT) 0)
	{
		SetAlphabet(sAlphabet);
	};

	virtual ~COneHot()
	{
		SetAlphabet(NULL);
	}

	VOID Load(CStream &Stream)
	{
		CHAR sAlphabet[MAX_BUFFER];

		Stream >> sAlphabet;
		SetAlphabet(sAlphabet);
		printf(" - Alphabet: %s\n", sAlphabet);
	}

	VOID SetAlphabet(
		const STR sAlphabet
	);

	INT GetVectorSize()
	{
		return m_iSize;
	}

	VOID Encode(
		const CHAR cInput,
		CVector *&pOutput
	);

	VOID Encode(
		const STR sInput,
		CList &Output
	);

	CHAR Decode(
		const REAL rTolerance,
		CVector &Input
	);

	INT Decode(
		const REAL rTolerance,
		CList &Input,
		STR sOutput,
		INT iLength
	);

};

#endif // _ONE_HOT_
