//*****************************************************************************
// TrainSet.h: Interface of the CTrainSet class
//*****************************************************************************

#ifndef _TRAIN_SET_
#define _TRAIN_SET_

//*****************************************************************************
class CPattern
{
// Members
public:
	CList Input;
	CList Desired;

// Methods
public:
	CPattern()
	:	Input(),
		Desired()
	{}

};

//*****************************************************************************
// Set of rated samples
class CTrainSet
{
// Members
private:
	INT m_iSize;
	INT m_iNext;
	CPattern **m_ppStorage;
	COneHot &m_OneHotIn;
	COneHot &m_OneHotOut;
	CRandom m_Scrambler;

// Methods
public:
	CTrainSet(
		const INT iSize,
		COneHot &OneHotIn,
		COneHot &OneHotOut
	);
	virtual ~CTrainSet();

	INT GetSize()
	{
		return m_iNext;
	}

	VOID Insert(CPattern *pSample);
	VOID Scramble();
	VOID Print();
	VOID Load(CStream &Stream);

	CPattern &operator ()(const INT iIndex)
	{
#ifdef CHECK_INDEX
		if(iIndex >= m_iNext || m_ppStorage == NULL)
			throw CException(INVALID_INDEX);
#endif // CHECK_INDEX
	
		return *m_ppStorage[iIndex];
	}

};

#endif // _TRAIN_SET_
