// WorldObjects.cpp: implementation of various world object types....
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void FixTurnNeckSeq(CGameCommandSeq *pGameCommandSeq)
{
    double turnval = 0;
    CGameCommandSeq tmpseq;

    // zistime, ci sa tam nachadza TURN
    CGameCommand *pGameCommand;
    while (pGameCommandSeq->GetGameCommand(&pGameCommand)) {
        if (pGameCommand->GetCmdType() == CT__TURN) {
            turnval = pGameCommand->GetDArg(1);
        }

        // prehodime do pomocnej sekvencie
        tmpseq.AddGameCommand(pGameCommand);
    }

    // vsetky TURN_NECKy upravime zohliadniac vykonany TURN
    while (tmpseq.GetGameCommand(&pGameCommand)) {
        if (pGameCommand->GetCmdType() == CT__NECK) {
            double newval = pGameCommand->GetDArg(1)-turnval;
            // FIXME: pridat orezanie
            pGameCommand->SetDArg(1, newval);
        }

        // po uprave vratime do povodnej sekvencie
        pGameCommandSeq->AddGameCommand(pGameCommand);
    }
}


double Quantize(double x,double d)
{
	return d*floor(x/d+0.5);
}

double ExpQuantize(double x,double de,double d)
{
	return Quantize(exp(Quantize(log(x),de)),d);
}


//double AngleDistance(double a1,double a2)
//{
//	double da=AngNormalise(a2)-AngNormalise(a1);
//
//	if(da >PI) da-=2*PI;
//	if(da<-PI) da+=2*PI;
//	return da;
//}



void CAgent::UpdateApproachDistances(const CMovingObject &obj,const CAgent &local)//ughly
{
	CAngular2DVector pt(obj.GetPosition());
	m_approach_distances[m_approach_distances.size()*pt.GetAngle()/2/PI] =
        __max(0,pt.GetDistance()-obj.GetPosition().GetDiffusion());
}

void CMovingObject::Precompute()
{
	if(m_see_status&SEE_SIDE)
	{
		m_see_status|=EXPECTED_SIDE;
	}

	if(m_see_status&SEE_NUMBER)
	{
		m_see_status|=EXPECTED_NUMBER;
	}

	if(m_see_status&SEE_ANGLE)
	{
		m_see_status|=EXPECTED_ANGLE;
	}

	if(m_see_status&SEE_DISTANCE)
	{
		m_see_status|=EXPECTED_DISTANCE;
	}

	if(m_see_status&SEE_ANGLE_CHANGE)
	{
		m_see_status|=EXPECTED_ANGLE_CHANGE;
	}

	if(m_see_status&SEE_DISTANCE_CHANGE)
	{
		m_see_status|=EXPECTED_DISTANCE_CHANGE;
	}

	if(m_see_status&SEE_BODY_DIRECTION)
	{
		m_see_status|=EXPECTED_BODY_DIRECTION;
	}

	if(m_see_status&SEE_NECK_DIRECTION)
	{
		m_see_status|=EXPECTED_NECK_DIRECTION;
	}

	if(m_see_status&SEE_STAMINA)
	{
		m_see_status|=EXPECTED_STAMINA;
	}

	if(m_see_status&SEE_EFFORT)
	{
		m_see_status|=EXPECTED_EFFORT;
	}

	m_see_status&=(EXPECTED_MASK);

	if(m_see_status&EXPECTED_ANGLE && m_see_status&EXPECTED_DISTANCE)
	{
		m_prev_position=m_position;
		m_see_status|=PREV_POSITION;
	}
	if(m_see_status&EXPECTED_ANGLE_CHANGE && m_see_status&EXPECTED_DISTANCE_CHANGE)
	{
		m_prev_speed=m_speed;
		m_see_status|=PREV_SPEED;
	}
	if(m_see_status&EXPECTED_ACCELERATION)
	{
		m_prev_acceleration=m_acceleration;
		m_see_status|=PREV_ACCELERATION;
	}
	m_position+=m_speed;
	m_speed=m_speed*0.9+m_acceleration;
	m_speed.SetDistance(__min(1,m_speed.GetDistance()));
//	double pos_un=1.0-m_speed.GetDistance();
	m_speed.SetDiffusion(__min(1,m_speed.GetDiffusion()));
	m_acceleration=CDiffuse2DVector(0,0,1);
}





CDiffuse2DVector DoFilter(CDiffuse2DVector org_val,CDiffuse2DVector new_val)
{
	double diff=__max(0,__min(2,new_val.GetDiffusion ()));
	double weight=0.75*exp(-1.4*diff);
	return org_val*(1-weight)+weight*new_val;
}









void CBall::UpdateBallPosition(CSeenObject _oBall,const CAgent &local)//ughly
{
	int flags=_oBall.GetSetValuesVar();
	
	if(flags &(SEE_ANGLE|SEE_DISTANCE))
	{
        m_see_status|=STATE_IS_VISIBLE;
        m_cLastVisible = local.GetTime();

        //fprintf(m_ff, "{ball %lf}\n", (double)_oBall.GetDirection());

//        if (fabs(_oBall.GetDirection())>15) 
//            fprintf(m_ff, "xx");

		CDiffuse2DVector position(CAngular2DVector(DegToRad(_oBall.GetDirection())+local.GetNeckDirection(),_oBall.GetDistance()),0.1,0.1,0.1);

		m_position=position+CDiffuse2DVector((C2DVector)local.GetPosition(),0);

        m_see_status|=SEE_ANGLE|SEE_DISTANCE;
		double e=1000;

		CDiffuse2DVector CSpeed,VSpeed;
		bool Cspeed_valid=false,Vspeed_valid=false;

		if((flags & SEE_ANGLE_CHANGE) &&(flags & SEE_DISTANCE_CHANGE))
		{
			CAngular2DVector normal (DegToRad(_oBall.GetDirection())+local.GetNeckDirection()     ,_oBall.GetDistanceChng());
			CAngular2DVector tangent(DegToRad(_oBall.GetDirection())+local.GetNeckDirection()+PI/2,DegToRad(_oBall.GetDirectionChng())*_oBall.GetDistance());

			e=(0.1+0.02*_oBall.GetDistance()+PI/180*_oBall.GetDistance())/2;

			VSpeed=CDiffuse2DVector((C2DVector)normal+(C2DVector)tangent,e)+local.GetSpeed ();

			if(VSpeed.GetDistance ()<3)
			{
				Vspeed_valid=true;
				if(VSpeed.GetDistance ()>1)
				{
					VSpeed.SetDistance (1);
				}
			}
		}

		if( m_see_status &PREV_POSITION)
		{
			//CSpeed=m_position-CDiffuse2DVector((C2DVector)local.GetPosition(),0)-m_prev_position+CDiffuse2DVector((C2DVector)local.GetPrevPosition(),0)+local.GetSpeed ();
			CSpeed=m_position-m_prev_position;
			//CSpeed=CDiffuse2DVector(2,2,1);
			Cspeed_valid=true;
		}
		        


		if(Vspeed_valid)
		{
//			if(e<0.1)
//			{
//				m_speed=VSpeed;
//			}
//			else
			{
				if(Cspeed_valid)
				{
					if(CSpeed.GetDiffusion ()<5*VSpeed.GetDiffusion ())
					{
						m_speed=DoFilter(m_speed,VSpeed);
						m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
					}
					else
					{
						m_speed=DoFilter(m_speed,VSpeed);
						m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
					}
					
				}
				else
				{
					m_speed=DoFilter(m_speed,VSpeed);
					m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
				}
			}
		}
		else
		{
			if(Cspeed_valid)
			{
				//m_speed=0.95*m_speed+0.05*CSpeed;
				m_speed=DoFilter(m_speed,CSpeed);
				m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
			}
		}
			
		//m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
	}
	if( (m_see_status &PREV_SPEED) && (m_see_status & SEE_ANGLE_CHANGE) && (m_see_status & SEE_DISTANCE_CHANGE))
	{
		m_acceleration=m_speed-m_prev_speed;
		m_acceleration=CDiffuse2DVector(0,0,0);
		m_see_status|=EXPECTED_ACCELERATION;
	}
}


void  CAgent::Precompute()//nasty
{
// PRECOMPUTE:
	CMovingObject::Precompute();

	m_acceleration=CDiffuse2DVector(0,0,0.6);

	m_see_status&=(~EXPECTED_ANGULAR_SPEED);
	
	if(m_see_status&EXPECTED_NECK_DIRECTION)
	{
		m_prev_neck_direction=m_neck_direction;
		m_see_status|=PREV_NECK_DIRECTION|EXPECTED_ANGULAR_SPEED;
	}
	m_angular_speed=0;
	
	if(m_my_world)
	{
		m_my_world->Precompute();
	}
}


CGameCommand * CAgent::GetCommand()
{
	return 0;
}

void CBall::Precompute()
{
// PRECOMPUTE:
 	CMovingObject::Precompute();
	m_acceleration=CDiffuse2DVector(0,0,0.0);
}


void CWorldModel::Recompute(CPerception *Perception,const CAgent &local)
{
    // BUG?: preco sa tu nastavuje, ze je visible??
	//m_ball->SetSeeStatus (0,STATE_IS_VISIBLE);
    //m_ball->m_cLastVisible = local.GetTime();
	
	CSeenObject tmp_ball;

	Perception->GetBall(&tmp_ball);

	m_ball->UpdateBallPosition(tmp_ball,local);



// PRECOMPUTE:

	//CSeenPlayersVect my_seen_vect=Perception->GetSeenPlayers();
	int seen_count=Perception->GetPlayersCount();
	int unid_count=m_unidentified_agents.size();
	int id_count=m_identified_agents.size();

	if(seen_count)
	{
		int rer=0;
		rer++;
	}

	int i,j;

	for(i=0;i<id_count;i++)
	{
		m_identified_agents[i]->SetSeeStatus(m_identified_agents[i]->GetSeeStatus()|STATE_IS_VISIBLE, 0);
        m_identified_agents[i]->m_cLastVisible = local.GetTime();
	}

	for(i=0;i<unid_count;i++)
	{
		m_unidentified_agents[i]->SetSeeStatus (m_unidentified_agents[i]->GetSeeStatus()|STATE_IS_VISIBLE, 0);
        m_unidentified_agents[i]->m_cLastVisible = local.GetTime();
	}

	double **id_vals;
	double **unid_vals;

	bool *matched_unid;
	bool *matched_seen;

	CSeenPlayer **act_seen;


	if(unid_count)
	{
		matched_unid=new bool   [unid_count];
		memset(matched_unid,0,unid_count*sizeof(bool));
	}


	
	
	if(seen_count)
	{
		CSeenPlayer *tmp_player=new CSeenPlayer;
		int tmp_poz=Perception->GetFirstPlayer (tmp_player);

		act_seen= new CSeenPlayer *[seen_count];

		if(id_count)
		{
			id_vals     =new double*[id_count  ];
		}
		if(unid_count)
		{
			unid_vals   =new double*[unid_count];
		}

		matched_seen=new bool[seen_count];
		memset(matched_seen,0,seen_count*sizeof(bool));

        act_seen[0]=tmp_player;
		for(i=1;i<seen_count;i++)
		{
			tmp_player=new CSeenPlayer;
			tmp_poz=Perception->GetNextPlayer (tmp_player,tmp_poz);
            act_seen[i]=tmp_player;
		}


		for(i=0;i<id_count;i++)
		{
			id_vals[i]=new double[seen_count];

			for(j=0;j<seen_count;j++)
			{
				id_vals[i][j]=m_identified_agents[i]->TestOwnership(*(act_seen[j]),local);
			}
		}

		for(i=0;i<unid_count;i++)
		{
			unid_vals[i]=new double[seen_count];

			for(j=0;j<seen_count;j++)
			{
				unid_vals[i][j]=m_unidentified_agents[i]->TestOwnership(*(act_seen[j]),local);
			}
		}
	}


	int i_id=-1,j_id=-1;

	double max_id=-1;

	int seen_rem=seen_count;

	bool not_hotovo=true;

	while(not_hotovo)
	{
		int i_unid=-1,j_unid=-1;

		double max_unid=-1;

		int i_id=-1,j_id=-1;

		double max_id=-1;

		for(i=0;i<unid_count;i++)
		{
			for(j=0;j<seen_count;j++)
			{
				if(max_unid<unid_vals[i][j])
				{
					i_unid=i;
					j_unid=j;
					max_unid=unid_vals[i][j];
				}
			}
		}

		for(i=0;i<id_count;i++)
		{
			for(j=0;j<seen_count;j++)
			{
				if(max_id<id_vals[i][j])
				{
					i_id=i;
					j_id=j;
					max_id=id_vals[i][j];
				}
			}
		}


		if(max_id>=max_unid)
		{
			if(max_id>0)
			{
				m_identified_agents[i_id]->Update(*(act_seen[j_id]),local);
				matched_seen[j_id]=true;

				for(j=0;j<seen_count;j++)
				{
					id_vals[i_id][j]=-1;
				}

				for(i=0;i<id_count;i++)
				{
					id_vals[i][j_id]=-1;
				}
			}
			else
			{
				not_hotovo=false;
			}
		}
		else
		{
			if(max_unid>0)
			{
				m_unidentified_agents[i_unid]->Update(*(act_seen[j_unid]),local);
				matched_unid[i_unid]=true;
				matched_seen[j_unid]=true;

				for(j=0;j<seen_count;j++)
				{
					unid_vals[i_unid][j]=-1;
				}

				for(i=0;i<unid_count;i++)
				{
					unid_vals[i][j_unid]=-1;
				}
			}
			else
			{
				not_hotovo=false;
			}
		}
	}


	for(i=0;i<unid_count;i++)
	{
		if(matched_unid[i])
		{
			if((m_unidentified_agents[i]->GetSeeStatus() & SEE_SIDE) &&(m_unidentified_agents[i]->GetSeeStatus() & SEE_NUMBER))
			{
				for(j=0;j<id_count;j++)
				{
					if(	m_identified_agents[j]->GetPlayerSide  ()==m_unidentified_agents[i]->GetPlayerSide  () &&
						m_identified_agents[j]->GetPlayerNumber()==m_unidentified_agents[i]->GetPlayerNumber()
					)
					{
						break;
					}
				}
				if(j!=id_count)
				{
					delete m_identified_agents[j];
					m_identified_agents[j]=m_unidentified_agents[i];
				}
				else
				{
					m_identified_agents.insert(m_identified_agents.end(),m_unidentified_agents[i]);
				}
				m_unidentified_agents[i]=0;
			}
		}
		else
		{
			delete m_unidentified_agents[i];
			m_unidentified_agents[i]=0;
		}
	}

	bool one_zero=true;

	while(one_zero)
	{
		one_zero=false;

		for(i=0;i<m_unidentified_agents.size();i++)
		{
			if(!m_unidentified_agents[i])
			{
				m_unidentified_agents.erase(&(m_unidentified_agents[i]));
				one_zero=true;
				break;
			}
		}
	}

	for(i=0;i<seen_count;i++)
	{
		if(!matched_seen[i])
		{
			CAgent *new_agent=new CAgent;
			new_agent->Update(*(act_seen[i]),local);

			if((new_agent->GetSeeStatus() &SEE_SIDE) &&(new_agent->GetSeeStatus() &SEE_NUMBER))
			{
				m_identified_agents.insert(m_identified_agents.end(),new_agent);
			}
			else
			{
				m_unidentified_agents.insert(m_unidentified_agents.end(),new_agent);
			}

		}
	}

	if(seen_count)
	{
		for(i=0;i<id_count;i++)
		{
			delete []id_vals[i];
		}
		if(id_count) delete []id_vals;

		for(i=0;i<unid_count;i++)
		{
			delete []unid_vals[i];
		}
		if(unid_count) delete []unid_vals;

		for(i=0;i<seen_count;i++)
		{
			delete act_seen[i];
		}
		delete []act_seen;
		delete []matched_seen;
	}

	if(unid_count) delete []matched_unid;
}


void CWorldModel::Precompute()
{
	//m_ball->Precompute();    // nechcem nadavat!!!!!
	int i;

	for(i=0;i<m_identified_agents.size();i++)
	{
		CDiffuse2DVector poz=m_ball->GetPosition()-m_identified_agents[i]->GetPosition();
		if(	(m_ball->GetSeeStatus ()&STATE_IS_VISIBLE) == (m_identified_agents[i]->GetSeeStatus ()&STATE_IS_VISIBLE) )
		{
			if(poz.GetDistance ()<1+poz.GetDiffusion ())
			{
				m_ball->SetAcceleration (m_ball->GetAcceleration ()+CDiffuse2DVector(0,0,2.7));
			}
		}
	}
	for(i=0;i<m_unidentified_agents.size();i++)
	{
		CDiffuse2DVector poz=m_ball->GetPosition()-m_unidentified_agents[i]->GetPosition();
		if(	(m_ball->GetSeeStatus ()&STATE_IS_VISIBLE) == (m_unidentified_agents[i]->GetSeeStatus ()&STATE_IS_VISIBLE) )
		{
			if(poz.GetDistance ()<1+poz.GetDiffusion ())
			{
				m_ball->SetAcceleration (m_ball->GetAcceleration ()+CDiffuse2DVector(0,0,2.7));
			}
		}
	}
	
	m_ball->Precompute();

// PRECOMPUTE:
	for(i=0;i<m_identified_agents.size();i++)
	{
		m_identified_agents[i]->Precompute();
	}
	for(i=0;i<m_unidentified_agents.size();i++)
	{
		m_unidentified_agents[i]->Precompute();
	}
}





double CAgent::TestOwnership(const CSeenPlayer &player,const CAgent &local)//ughly
{
	int flags=player.GetSetValuesVar();

	if((flags&SEE_SIDE) && ((m_see_status&SEE_SIDE) || (m_see_status&EXPECTED_SIDE) ) && ( (m_side==local.m_side)!=(player.GetSide())) )
	{
		return 0;
	}

	if((flags&SEE_NUMBER) && ((m_see_status&SEE_NUMBER) || (m_see_status&EXPECTED_NUMBER) ) && (m_number!=player.GetUniformNum()))
	{
		return 0;
	}

	if((flags&SEE_SIDE) && ((m_see_status&SEE_SIDE) || (m_see_status&EXPECTED_SIDE)) && (flags&SEE_NUMBER) && ((m_see_status&SEE_NUMBER) || (m_see_status&EXPECTED_NUMBER) ))
	{
		return 1;
	}
////////////!!!!!!!!!

	if(flags &(SEE_ANGLE|SEE_DISTANCE))
	{
		CDiffuse2DVector position(CAngular2DVector(DegToRad(player.GetDirection())+local.GetNeckDirection(),player.GetDistance()),0.1,0.1,0.1);

		CDiffuse2DVector delta=m_position-position-local.GetPosition();

		if(delta.GetDiffusion ()>4)
		{
			delta.SetDiffusion (4);
		}
		
		if(delta.GetDistance ()>20)
		{
			return 0;
		}
		
		return 0.9*exp(-delta.GetDistance()/delta.GetDiffusion());
	}
	return 0;// CAUTION AGENT IS BLIND !!!
}



void CAgent::Update(CSeenPlayer &player,const CAgent &local)//ughly
{
	int nn;
	int flags=player.GetSetValuesVar();
	ESide sd=m_side;

	if(flags&SEE_SIDE)
	{

        // FIXME
		m_see_status|=SEE_SIDE;
        if (player.GetSide())
		{
            m_side=local.GetPlayerSide();
		}
        else 
		{
            m_side=(local.GetPlayerSide()==S_Left)?S_Right:S_Left;
		}
	}
	else
	{
		if((m_see_status&SEE_SIDE) || (m_see_status&EXPECTED_SIDE))
		{
			nn=sd;
		}
	}

	if(sd!=m_side)
	{
		nn=sd;
	}
	int num=m_number;

	if(flags&SEE_NUMBER)
	{
		m_number=player.GetUniformNum();
		m_see_status|=SEE_NUMBER;
	}
	if(m_number!=num)
	{
		num++;
		num--;
	}


	if(flags&SEE_BODY_DIRECTION)
	{
		m_direction=AngNormalise((double)DegToRad(player.GetBodyDir())+local.GetNeckDirection());
		m_see_status|=SEE_BODY_DIRECTION;
	}

	if(flags&SEE_NECK_DIRECTION)
	{
		m_neck_direction=AngNormalise((double)DegToRad(player.GetHeadDir())+local.GetNeckDirection());
		m_see_status|=SEE_NECK_DIRECTION;
	}

	
	if(flags &(SEE_ANGLE|SEE_DISTANCE))
	{
		m_see_status|=STATE_IS_VISIBLE;
//        fprintf(m_ff, "{ball %lf}\n", (double)_oBall.GetDirection());
		
		//        if (fabs(_oBall.GetDirection())>15) 
		//            fprintf(m_ff, "xx");
		
		CDiffuse2DVector position(CAngular2DVector(DegToRad(player.GetDirection())+local.GetNeckDirection(),player.GetDistance()),0.1,0.1,0.1);
		
		m_position=position+CDiffuse2DVector((C2DVector)local.GetPosition(),0);
		
        m_see_status|=SEE_ANGLE|SEE_DISTANCE;
		double e=1000;
		
		CDiffuse2DVector CSpeed,VSpeed;
		bool Cspeed_valid=false,Vspeed_valid=false;
		
		if((flags & SEE_ANGLE_CHANGE) &&(flags & SEE_DISTANCE_CHANGE))
		{
			CAngular2DVector normal (DegToRad(player.GetDirection())+local.GetNeckDirection()     ,player.GetDistanceChng());
			CAngular2DVector tangent(DegToRad(player.GetDirection())+local.GetNeckDirection()+PI/2,DegToRad(player.GetDirectionChng())*player.GetDistance());
			
			e=(0.1+0.02* player.GetDistance()+PI/180*player.GetDistance())/2;
			
			VSpeed=CDiffuse2DVector((C2DVector)normal+(C2DVector)tangent,e)+local.GetSpeed ();
			
			if(VSpeed.GetDistance ()<3)
			{
				Vspeed_valid=true;
				if(VSpeed.GetDistance ()>1)
				{
					VSpeed.SetDistance (1);
				}
			}
		}
		
		if( m_see_status &PREV_POSITION)
		{
			//CSpeed=m_position-CDiffuse2DVector((C2DVector)local.GetPosition(),0)-m_prev_position+CDiffuse2DVector((C2DVector)local.GetPrevPosition(),0)+local.GetSpeed ();
			CSpeed=m_position-m_prev_position;
			Cspeed_valid=true;
		}
		
		
		
		if(Vspeed_valid)
		{
			//			if(e<0.1)
			//			{
			//				m_speed=VSpeed;
			//			}
			//			else
			{
				if(Cspeed_valid)
				{
					if(CSpeed.GetDiffusion ()<5*VSpeed.GetDiffusion ())
					{
						m_speed=DoFilter(m_speed,VSpeed);
						m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
					}
					else
					{
						m_speed=DoFilter(m_speed,VSpeed);
						m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
					}
					
				}
				else
				{
					m_speed=DoFilter(m_speed,VSpeed);
					m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
				}
			}
		}
		else
		{
			if(Cspeed_valid)
			{
				//m_speed=0.95*m_speed+0.05*CSpeed;
				m_speed=DoFilter(m_speed,CSpeed);
				m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
			}
		}
		
		//m_see_status|=SEE_ANGLE_CHANGE|SEE_DISTANCE_CHANGE;
	}
	if( (m_see_status &PREV_SPEED) && (m_see_status & SEE_ANGLE_CHANGE) && (m_see_status & SEE_DISTANCE_CHANGE))
	{
		//m_acceleration=m_speed-m_prev_speed;
		//m_acceleration=CDiffuse2DVector(0,0,0);
		m_see_status|=EXPECTED_ACCELERATION;
	}
}
